#include <inttypes.h>
using namespace std;

//factorial
long fact(int n);
//binomial coefficient
long binom(int n, int k);

// NOTE: no memory allocation is made in genComb, combine, genPerm and permute
//       proper allocation must be done prior to using these functions!

//save all k-combinations of the set 1..n into w
// w[0] is a k-element array containing the first combination (no particular order)
// w[1] is a k-element array containing the second combination, etc.
// w[binom(n,k)-1] contains the last combination
void genComb(int n, int k, int** w);

//save all k-combinations of n-element set S into w
void combine(const int *S, int n, int k, int** w);

//save all permutations of the set 1..n into w
// w[0] is a n-element array containing the first permutation (no particular order)
// w[1] is a n-element array conatining the second permutation, etc.
// w[fact(n)-1] contains the last permutation
void genPerm(int n, int** w);

//save all permutations of n-element set S into w
void permute(const int* S, int n, int** w);

// NOTE: this type must hold at least MAX_SIZE bits
typedef uint32_t hash_t;

// hash value of the first (order given by hash values) k-element subset of the set 1..n
hash_t firstSet(int n, int k);
// hash value of a k-element subset of 1..n following the set s
hash_t nextSet(hash_t s, int n, int k);

